
_Main_Init:

;electronique_controleur_dmx_001_16f88.mpas,52 :: 		begin
;electronique_controleur_dmx_001_16f88.mpas,53 :: 		CMCON := CMCON or $07;  // turn off comparators
	MOVLW      7
	IORWF      CMCON+0, 1
;electronique_controleur_dmx_001_16f88.mpas,54 :: 		OPTION_REG.NOT_RBPU := 0;   // enable pullup
	BCF        OPTION_REG+0, 7
;electronique_controleur_dmx_001_16f88.mpas,55 :: 		INTCON := $00;
	CLRF       INTCON+0
;electronique_controleur_dmx_001_16f88.mpas,56 :: 		TRISA := %11111111;
	MOVLW      255
	MOVWF      TRISA+0
;electronique_controleur_dmx_001_16f88.mpas,57 :: 		TRISB := %10000000;
	MOVLW      128
	MOVWF      TRISB+0
;electronique_controleur_dmx_001_16f88.mpas,58 :: 		PORTA := $00;
	CLRF       PORTA+0
;electronique_controleur_dmx_001_16f88.mpas,59 :: 		PORTB := $00;
	CLRF       PORTB+0
;electronique_controleur_dmx_001_16f88.mpas,60 :: 		ANSEL := 0;
	CLRF       ANSEL+0
;electronique_controleur_dmx_001_16f88.mpas,61 :: 		ANSEL.ANS0 := 1; // set RA0 as analog input
	BSF        ANSEL+0, 0
;electronique_controleur_dmx_001_16f88.mpas,62 :: 		ANSEL.ANS1 := 1; // set RA1 as analog input
	BSF        ANSEL+0, 1
;electronique_controleur_dmx_001_16f88.mpas,63 :: 		ANSEL.ANS2 := 1; // set RA2 as analog input
	BSF        ANSEL+0, 2
;electronique_controleur_dmx_001_16f88.mpas,64 :: 		ANSEL.ANS3 := 1; // set RA3 as analog input
	BSF        ANSEL+0, 3
;electronique_controleur_dmx_001_16f88.mpas,65 :: 		ANSEL.ANS4 := 1; // set RA4 as analog input
	BSF        ANSEL+0, 4
;electronique_controleur_dmx_001_16f88.mpas,68 :: 		ADC_Init;
	CALL       _ADC_Init+0
;electronique_controleur_dmx_001_16f88.mpas,75 :: 		TXSTA.TX9 := 1;     // 9-bits transmission
	BSF        TXSTA+0, 6
;electronique_controleur_dmx_001_16f88.mpas,76 :: 		TXSTA.TXEN := 1;    // Tx enabled
	BSF        TXSTA+0, 5
;electronique_controleur_dmx_001_16f88.mpas,77 :: 		TXSTA.BRGH := 1;
	BSF        TXSTA+0, 2
;electronique_controleur_dmx_001_16f88.mpas,78 :: 		RCSTA.SPEN := 0;    // UART will be enabled latter;
	BCF        RCSTA+0, 7
;electronique_controleur_dmx_001_16f88.mpas,79 :: 		RCSTA.TX9 := 1;     // 9-bits transmission
	BSF        RCSTA+0, 6
;electronique_controleur_dmx_001_16f88.mpas,80 :: 		UART1_Init(cDMXBaudRate);  // speed for DMX communication
	MOVLW      4
	MOVWF      SPBRG+0
	BSF        TXSTA+0, 2
	CALL       _UART1_Init+0
;electronique_controleur_dmx_001_16f88.mpas,81 :: 		Delay_ms(200);      // let UART initialize
	MOVLW      6
	MOVWF      R11+0
	MOVLW      19
	MOVWF      R12+0
	MOVLW      173
	MOVWF      R13+0
L__Main_Init1:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Init1
	DECFSZ     R12+0, 1
	GOTO       L__Main_Init1
	DECFSZ     R11+0, 1
	GOTO       L__Main_Init1
	NOP
	NOP
;electronique_controleur_dmx_001_16f88.mpas,83 :: 		Out_Tx := 1;
	BSF        RB5_bit+0, 5
;electronique_controleur_dmx_001_16f88.mpas,85 :: 		end;
L_end_Main_Init:
	RETURN
; end of _Main_Init

_Values_Read:

;electronique_controleur_dmx_001_16f88.mpas,88 :: 		begin
;electronique_controleur_dmx_001_16f88.mpas,89 :: 		ArrData[0] := ADC_Get_Sample(0) SHR 3;           // stroboscope
	CLRF       FARG_ADC_Get_Sample_channel+0
	CALL       _ADC_Get_Sample+0
	MOVF       R0+0, 0
	MOVWF      R2+0
	MOVF       R0+1, 0
	MOVWF      R2+1
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	MOVF       R2+0, 0
	MOVWF      _ArrData+0
;electronique_controleur_dmx_001_16f88.mpas,90 :: 		ArrData[1] := (ADC_Get_Sample(1) SHR 3) + 128;   // general RGB dimmer
	MOVLW      1
	MOVWF      FARG_ADC_Get_Sample_channel+0
	CALL       _ADC_Get_Sample+0
	MOVF       R0+0, 0
	MOVWF      R2+0
	MOVF       R0+1, 0
	MOVWF      R2+1
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	MOVLW      128
	ADDWF      R2+0, 0
	MOVWF      _ArrData+1
;electronique_controleur_dmx_001_16f88.mpas,91 :: 		ArrData[2] := ADC_Get_Sample(2) SHR 2;           // R dimmer
	MOVLW      2
	MOVWF      FARG_ADC_Get_Sample_channel+0
	CALL       _ADC_Get_Sample+0
	MOVF       R0+0, 0
	MOVWF      R2+0
	MOVF       R0+1, 0
	MOVWF      R2+1
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	MOVF       R2+0, 0
	MOVWF      _ArrData+2
;electronique_controleur_dmx_001_16f88.mpas,92 :: 		ArrData[3] := ADC_Get_Sample(3) SHR 2;           // G dimmer
	MOVLW      3
	MOVWF      FARG_ADC_Get_Sample_channel+0
	CALL       _ADC_Get_Sample+0
	MOVF       R0+0, 0
	MOVWF      R2+0
	MOVF       R0+1, 0
	MOVWF      R2+1
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	MOVF       R2+0, 0
	MOVWF      _ArrData+3
;electronique_controleur_dmx_001_16f88.mpas,93 :: 		ArrData[4] := ADC_Get_Sample(4) SHR 2;           // B dimmer
	MOVLW      4
	MOVWF      FARG_ADC_Get_Sample_channel+0
	CALL       _ADC_Get_Sample+0
	MOVF       R0+0, 0
	MOVWF      R2+0
	MOVF       R0+1, 0
	MOVWF      R2+1
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	MOVF       R2+0, 0
	MOVWF      _ArrData+4
;electronique_controleur_dmx_001_16f88.mpas,94 :: 		end;
L_end_Values_Read:
	RETURN
; end of _Values_Read

_DMX_Send:

;electronique_controleur_dmx_001_16f88.mpas,97 :: 		begin
;electronique_controleur_dmx_001_16f88.mpas,119 :: 		Out_Tx := 0;
	BCF        RB5_bit+0, 5
;electronique_controleur_dmx_001_16f88.mpas,120 :: 		Delay_us(100);    // 88 us min
	MOVLW      166
	MOVWF      R13+0
L__DMX_Send4:
	DECFSZ     R13+0, 1
	GOTO       L__DMX_Send4
	NOP
;electronique_controleur_dmx_001_16f88.mpas,123 :: 		Out_Tx := 1;
	BSF        RB5_bit+0, 5
;electronique_controleur_dmx_001_16f88.mpas,124 :: 		Delay_us(12);     // 8 us .. 1000 us, 12 us seems to be a good general value
	MOVLW      19
	MOVWF      R13+0
L__DMX_Send5:
	DECFSZ     R13+0, 1
	GOTO       L__DMX_Send5
	NOP
	NOP
;electronique_controleur_dmx_001_16f88.mpas,127 :: 		RCSTA.SPEN := 1;  // UART enabled
	BSF        RCSTA+0, 7
;electronique_controleur_dmx_001_16f88.mpas,130 :: 		TXSTA.TX9D := 1;
	BSF        TXSTA+0, 0
;electronique_controleur_dmx_001_16f88.mpas,133 :: 		UART1_Write(0);  // zero value for dimmers
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_controleur_dmx_001_16f88.mpas,136 :: 		if In_Mode then
	BTFSS      RB7_bit+0, 7
	GOTO       L__DMX_Send7
;electronique_controleur_dmx_001_16f88.mpas,137 :: 		UART1_Write(ArrData[0])   // stroboscope
	MOVF       _ArrData+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	GOTO       L__DMX_Send8
;electronique_controleur_dmx_001_16f88.mpas,138 :: 		else
L__DMX_Send7:
;electronique_controleur_dmx_001_16f88.mpas,139 :: 		UART1_Write(ArrData[1]);  // general RGB dimmer
	MOVF       _ArrData+1, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
L__DMX_Send8:
;electronique_controleur_dmx_001_16f88.mpas,140 :: 		UART1_Write(ArrData[2]);    // R dimmer
	MOVF       _ArrData+2, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_controleur_dmx_001_16f88.mpas,141 :: 		UART1_Write(ArrData[3]);    // G dimmer
	MOVF       _ArrData+3, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_controleur_dmx_001_16f88.mpas,142 :: 		UART1_Write(ArrData[4]);    // B dimmer
	MOVF       _ArrData+4, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_controleur_dmx_001_16f88.mpas,154 :: 		UART1_Write($00); UART1_Write($00); UART1_Write($00); UART1_Write($00);
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_controleur_dmx_001_16f88.mpas,155 :: 		UART1_Write($00); UART1_Write($00); UART1_Write($00); UART1_Write($00);
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_controleur_dmx_001_16f88.mpas,156 :: 		UART1_Write($00); UART1_Write($00); UART1_Write($00); UART1_Write($00);
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_controleur_dmx_001_16f88.mpas,157 :: 		UART1_Write($00); UART1_Write($00); UART1_Write($00); UART1_Write($00);
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_controleur_dmx_001_16f88.mpas,158 :: 		UART1_Write($00); UART1_Write($00); UART1_Write($00); UART1_Write($00);
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	CLRF       FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_controleur_dmx_001_16f88.mpas,161 :: 		Delay_us(10);
	MOVLW      16
	MOVWF      R13+0
L__DMX_Send9:
	DECFSZ     R13+0, 1
	GOTO       L__DMX_Send9
	NOP
;electronique_controleur_dmx_001_16f88.mpas,164 :: 		RCSTA.SPEN := 0;    // Tx disabled
	BCF        RCSTA+0, 7
;electronique_controleur_dmx_001_16f88.mpas,167 :: 		Delay_us(100);
	MOVLW      166
	MOVWF      R13+0
L__DMX_Send10:
	DECFSZ     R13+0, 1
	GOTO       L__DMX_Send10
	NOP
;electronique_controleur_dmx_001_16f88.mpas,169 :: 		end;
L_end_DMX_Send:
	RETURN
; end of _DMX_Send

_main:

;electronique_controleur_dmx_001_16f88.mpas,171 :: 		begin
;electronique_controleur_dmx_001_16f88.mpas,172 :: 		Main_Init;
	CALL       _Main_Init+0
;electronique_controleur_dmx_001_16f88.mpas,173 :: 		ADC_Init;
	CALL       _ADC_Init+0
;electronique_controleur_dmx_001_16f88.mpas,174 :: 		while true do
L__main13:
;electronique_controleur_dmx_001_16f88.mpas,176 :: 		Values_Read;
	CALL       _Values_Read+0
;electronique_controleur_dmx_001_16f88.mpas,177 :: 		DMX_Send;
	CALL       _DMX_Send+0
;electronique_controleur_dmx_001_16f88.mpas,178 :: 		end;
	GOTO       L__main13
;electronique_controleur_dmx_001_16f88.mpas,179 :: 		end.
L_end_main:
	GOTO       $+0
; end of _main
